--- xpdf-3.02/fofi/FoFiTrueType.cc
+++ xpdf-3.02/fofi/FoFiTrueType.cc
@@ -396,7 +396,7 @@
   return nameToGID->lookupInt(name);
 }
 
-Gushort *FoFiTrueType::getCIDToGIDMap(int *nCIDs) {
+Gushort *FoFiTrueType::getCIDToGIDMap(SafeInt *nCIDs) {
   FoFiType1C *ff;
   Gushort *map;
   int i;
@@ -504,7 +504,7 @@
 }
 
 void FoFiTrueType::convertToCIDType2(char *psName,
-				     Gushort *cidMap, int nCIDs,
+				     Gushort *cidMap, SafeInt nCIDs,
 				     GBool needVerticalMetrics,
 				     FoFiOutputFunc outputFunc,
 				     void *outputStream) {
@@ -538,7 +538,7 @@
   (*outputFunc)(outputStream, "  end def\n", 10);
   (*outputFunc)(outputStream, "/GDBytes 2 def\n", 15);
   if (cidMap) {
-    buf = GString::format("/CIDCount {0:d} def\n", nCIDs);
+    buf = GString::format("/CIDCount {0:d} def\n", nCIDs.Int());
     (*outputFunc)(outputStream, buf->getCString(), buf->getLength());
     delete buf;
     if (nCIDs > 32767) {
@@ -577,13 +577,13 @@
     }
   } else {
     // direct mapping - just fill the string(s) with s[i]=i
-    buf = GString::format("/CIDCount {0:d} def\n", nGlyphs);
+    buf = GString::format("/CIDCount {0:d} def\n", nGlyphs.Int());
     (*outputFunc)(outputStream, buf->getCString(), buf->getLength());
     delete buf;
     if (nGlyphs > 32767) {
       (*outputFunc)(outputStream, "/CIDMap [\n", 10);
       for (i = 0; i < nGlyphs; i += 32767) {
-	j = nGlyphs - i < 32767 ? nGlyphs - i : 32767;
+	j = nGlyphs.Int() - i < 32767 ? nGlyphs.Int() - i : 32767;
 	buf = GString::format("  {0:d} string 0 1 {1:d} {{\n", 2 * j, j - 1);
 	(*outputFunc)(outputStream, buf->getCString(), buf->getLength());
 	delete buf;
@@ -599,10 +599,10 @@
       }
       (*outputFunc)(outputStream, "] def\n", 6);
     } else {
-      buf = GString::format("/CIDMap {0:d} string\n", 2 * nGlyphs);
+      buf = GString::format("/CIDMap {0:d} string\n", 2 * nGlyphs.Int());
       (*outputFunc)(outputStream, buf->getCString(), buf->getLength());
       delete buf;
-      buf = GString::format("  0 1 {0:d} {{\n", nGlyphs - 1);
+      buf = GString::format("  0 1 {0:d} {{\n", nGlyphs.Int() - 1);
       (*outputFunc)(outputStream, buf->getCString(), buf->getLength());
       delete buf;
       (*outputFunc)(outputStream,
@@ -654,7 +654,7 @@
   delete ff;
 }
 
-void FoFiTrueType::convertToType0(char *psName, Gushort *cidMap, int nCIDs,
+void FoFiTrueType::convertToType0(char *psName, Gushort *cidMap, SafeInt nCIDs,
 				  GBool needVerticalMetrics,
 				  FoFiOutputFunc outputFunc,
 				  void *outputStream) {
@@ -672,7 +672,7 @@
   delete sfntsName;
 
   // write the descendant Type 42 fonts
-  n = cidMap ? nCIDs : nGlyphs;
+  n = cidMap ? nCIDs.Int() : nGlyphs.Int();
   for (i = 0; i < n; i += 256) {
     (*outputFunc)(outputStream, "10 dict begin\n", 14);
     (*outputFunc)(outputStream, "/FontName /", 11);
@@ -836,12 +836,13 @@
   };
   GBool missingCmap, missingName, missingPost, missingOS2;
   GBool unsortedLoca, badCmapLen, abbrevHMTX;
-  int nZeroLengthTables;
+  SafeInt nZeroLengthTables;
   int nHMetrics, advWidth, lsb;
   TrueTypeLoca *locaTable;
   TrueTypeTable *newTables;
   char *newNameTab, *newCmapTab, *newHHEATab, *newHMTXTab;
-  int nNewTables, cmapIdx, cmapLen, glyfLen, newNameLen, newCmapLen, next;
+  SafeInt nNewTables;
+  int cmapIdx, cmapLen, glyfLen, newNameLen, newCmapLen, next;
   int newHHEALen, newHMTXLen;
   Guint locaChecksum, glyfChecksum, fileChecksum;
   char *tableDir;
@@ -866,7 +867,7 @@
   missingOS2 = seekTable("OS/2") < 0;
 
   // read the loca table, check to see if it's sorted
-  locaTable = (TrueTypeLoca *)gmallocn(nGlyphs + 1, sizeof(TrueTypeLoca));
+  locaTable = (TrueTypeLoca *)gmallocn(nGlyphs + SafeInt(1), sizeof(TrueTypeLoca));
   unsortedLoca = gFalse;
   i = seekTable("loca");
   pos = tables[i].offset;
@@ -943,13 +944,13 @@
   // the same pos value remain in the same order)
   glyfLen = 0; // make gcc happy
   if (unsortedLoca) {
-    qsort(locaTable, nGlyphs + 1, sizeof(TrueTypeLoca),
+    qsort(locaTable, nGlyphs.Int() + 1, sizeof(TrueTypeLoca),
 	  &cmpTrueTypeLocaOffset);
     for (i = 0; i < nGlyphs; ++i) {
       locaTable[i].len = locaTable[i+1].origOffset - locaTable[i].origOffset;
     }
-    locaTable[nGlyphs].len = 0;
-    qsort(locaTable, nGlyphs + 1, sizeof(TrueTypeLoca),
+    locaTable[nGlyphs.Int()].len = 0;
+    qsort(locaTable, nGlyphs.Int() + 1, sizeof(TrueTypeLoca),
 	  &cmpTrueTypeLocaIdx);
     pos = 0;
     for (i = 0; i <= nGlyphs; ++i) {
@@ -992,7 +993,7 @@
   // construct the new name table
   if (name) {
     n = strlen(name);
-    newNameLen = (6 + 4*12 + 2 * (3*n + 7) + 3) & ~3;
+    newNameLen = (6 + 4*12 + 2 * (3*SafeInt(n) + 7) + 3).Int() & ~3;
     newNameTab = (char *)gmalloc(newNameLen);
     memset(newNameTab, 0, newNameLen);
     newNameTab[0] = 0;		// format selector
@@ -1097,11 +1098,11 @@
     for (i = 0; i < newHHEALen; ++i) {
       newHHEATab[i] = getU8(pos++, &ok);
     }
-    newHHEATab[34] = nGlyphs >> 8;
-    newHHEATab[35] = nGlyphs & 0xff;
+    newHHEATab[34] = nGlyphs.Int() >> 8;
+    newHHEATab[35] = nGlyphs.Int() & 0xff;
     i = seekTable("hmtx");
     pos = tables[i].offset;
-    newHMTXLen = 4 * nGlyphs;
+    newHMTXLen = (4 * nGlyphs).Int();
     newHMTXTab = (char *)gmalloc(newHMTXLen);
     advWidth = 0;
     for (i = 0; i < nHMetrics; ++i) {
@@ -1157,7 +1158,7 @@
       } else if (newTables[j].tag == cmapTag && badCmapLen) {
 	newTables[j].len = cmapLen;
       } else if (newTables[j].tag == locaTag && unsortedLoca) {
-	newTables[j].len = (nGlyphs + 1) * (locaFmt ? 4 : 2);
+	newTables[j].len = (nGlyphs.Int() + 1) * (locaFmt ? 4 : 2);
 	newTables[j].checksum = locaChecksum;
       } else if (newTables[j].tag == glyfTag && unsortedLoca) {
 	newTables[j].len = glyfLen;
@@ -1218,9 +1219,9 @@
     newTables[j].len = sizeof(os2Tab);
     ++j;
   }
-  qsort(newTables, nNewTables, sizeof(TrueTypeTable),
+  qsort(newTables, nNewTables.Int(), sizeof(TrueTypeTable),
 	&cmpTrueTypeTableTag);
-  pos = 12 + nNewTables * 16;
+  pos = 12 + nNewTables.Int() * 16;
   for (i = 0; i < nNewTables; ++i) {
     newTables[i].offset = pos;
     pos += newTables[i].len;
@@ -1230,20 +1231,20 @@
   }
 
   // write the table directory
-  tableDir = (char *)gmalloc(12 + nNewTables * 16);
+  tableDir = (char *)gmalloc((SafeInt(12) + nNewTables * SafeInt(16)).Int());
   tableDir[0] = 0x00;					// sfnt version
   tableDir[1] = 0x01;
   tableDir[2] = 0x00;
   tableDir[3] = 0x00;
-  tableDir[4] = (char)((nNewTables >> 8) & 0xff);	// numTables
-  tableDir[5] = (char)(nNewTables & 0xff);
-  for (i = -1, t = (Guint)nNewTables; t; ++i, t >>= 1) ;
+  tableDir[4] = (char)((nNewTables.Int() >> 8) & 0xff);	// numTables
+  tableDir[5] = (char)(nNewTables.Int() & 0xff);
+  for (i = -1, t = (Guint)nNewTables.Int(); t; ++i, t >>= 1) ;
   t = 1 << (4 + i);
   tableDir[6] = (char)((t >> 8) & 0xff);		// searchRange
   tableDir[7] = (char)(t & 0xff);
   tableDir[8] = (char)((i >> 8) & 0xff);		// entrySelector
   tableDir[9] = (char)(i & 0xff);
-  t = nNewTables * 16 - t;
+  t = nNewTables.Int() * 16 - t;
   tableDir[10] = (char)((t >> 8) & 0xff);		// rangeShift
   tableDir[11] = (char)(t & 0xff);
   pos = 12;
@@ -1266,11 +1267,11 @@
     tableDir[pos+15] = (char) newTables[i].len;
     pos += 16;
   }
-  (*outputFunc)(outputStream, tableDir, 12 + nNewTables * 16);
+  (*outputFunc)(outputStream, tableDir, 12 + nNewTables.Int() * 16);
 
   // compute the file checksum
   fileChecksum = computeTableChecksum((Guchar *)tableDir,
-				      12 + nNewTables * 16);
+				      12 + nNewTables.Int() * 16);
   for (i = 0; i < nNewTables; ++i) {
     fileChecksum += newTables[i].checksum;
   }
@@ -1458,7 +1459,7 @@
   Guchar tableDir[12 + nT42Tables*16];
   GBool ok;
   Guint checksum;
-  int nNewTables;
+  SafeInt nNewTables;
   int length, pos, glyfPos, i, j, k;
   Guchar vheaTab[36] = {
     0, 1, 0, 0,			// table version number
@@ -1499,7 +1500,7 @@
   // table, cmpTrueTypeLocaPos uses offset as its primary sort key,
   // and idx as its secondary key (ensuring that adjacent entries with
   // the same pos value remain in the same order)
-  locaTable = (TrueTypeLoca *)gmallocn(nGlyphs + 1, sizeof(TrueTypeLoca));
+  locaTable = (TrueTypeLoca *)gmallocn(nGlyphs + SafeInt(1), sizeof(TrueTypeLoca));
   i = seekTable("loca");
   pos = tables[i].offset;
   ok = gTrue;
@@ -1511,13 +1512,13 @@
       locaTable[i].origOffset = 2 * getU16BE(pos + i*2, &ok);
     }
   }
-  qsort(locaTable, nGlyphs + 1, sizeof(TrueTypeLoca),
+  qsort(locaTable, nGlyphs.Int() + 1, sizeof(TrueTypeLoca),
 	&cmpTrueTypeLocaOffset);
   for (i = 0; i < nGlyphs; ++i) {
     locaTable[i].len = locaTable[i+1].origOffset - locaTable[i].origOffset;
   }
-  locaTable[nGlyphs].len = 0;
-  qsort(locaTable, nGlyphs + 1, sizeof(TrueTypeLoca),
+  locaTable[nGlyphs.Int()].len = 0;
+  qsort(locaTable, nGlyphs.Int() + 1, sizeof(TrueTypeLoca),
 	&cmpTrueTypeLocaIdx);
   pos = 0;
   for (i = 0; i <= nGlyphs; ++i) {
@@ -1529,7 +1530,7 @@
   }
 
   // construct the new 'loca' table
-  locaData = (Guchar *)gmallocn(nGlyphs + 1, (locaFmt ? 4 : 2));
+  locaData = (Guchar *)gmallocn(nGlyphs + SafeInt(1), (locaFmt ? 4 : 2));
   for (i = 0; i <= nGlyphs; ++i) {
     pos = locaTable[i].newOffset;
     if (locaFmt) {
@@ -1570,7 +1571,7 @@
 
   // construct the new table headers, including table checksums
   // (pad each table out to a multiple of 4 bytes)
-  pos = 12 + nNewTables*16;
+  pos = 12 + nNewTables.Int()*16;
   k = 0;
   for (i = 0; i < nT42Tables; ++i) {
     length = -1;
@@ -1579,7 +1580,7 @@
       length = 54;
       checksum = computeTableChecksum(headData, 54);
     } else if (i == t42LocaTable) {
-      length = (nGlyphs + 1) * (locaFmt ? 4 : 2);
+      length = (nGlyphs.Int() + 1) * (locaFmt ? 4 : 2);
       checksum = computeTableChecksum(locaData, length);
     } else if (i == t42GlyfTable) {
       length = 0;
@@ -1608,7 +1609,7 @@
 	length = sizeof(vheaTab);
 	checksum = computeTableChecksum(vheaTab, length);
       } else if (needVerticalMetrics && i == t42VmtxTable) {
-	length = 4 + (nGlyphs - 1) * 4;
+	length = (4 + (nGlyphs - 1) * 4).Int();
 	vmtxTab = (Guchar *)gmalloc(length);
 	vmtxTab[0] = advance / 256;
 	vmtxTab[1] = advance % 256;
@@ -1646,13 +1647,13 @@
   tableDir[2] = 0x00;
   tableDir[3] = 0x00;
   tableDir[4] = 0;		// numTables
-  tableDir[5] = nNewTables;
+  tableDir[5] = nNewTables.Int();
   tableDir[6] = 0;		// searchRange
   tableDir[7] = (Guchar)128;
   tableDir[8] = 0;		// entrySelector
   tableDir[9] = 3;
   tableDir[10] = 0;		// rangeShift
-  tableDir[11] = (Guchar)(16 * nNewTables - 128);
+  tableDir[11] = (Guchar)(16 * nNewTables.Int() - 128);
   pos = 12;
   for (i = 0; i < nNewTables; ++i) {
     tableDir[pos   ] = (Guchar)(newTables[i].tag >> 24);
@@ -1675,7 +1676,7 @@
   }
 
   // compute the font checksum and store it in the head table
-  checksum = computeTableChecksum(tableDir, 12 + nNewTables*16);
+  checksum = computeTableChecksum(tableDir, 12 + nNewTables.Int()*16);
   for (i = 0; i < nNewTables; ++i) {
     checksum += newTables[i].checksum;
   }
@@ -1695,14 +1696,14 @@
   }
 
   // write the table directory
-  dumpString(tableDir, 12 + nNewTables*16, outputFunc, outputStream);
+  dumpString(tableDir, 12 + nNewTables.Int()*16, outputFunc, outputStream);
 
   // write the tables
   for (i = 0; i < nNewTables; ++i) {
     if (i == t42HeadTable) {
       dumpString(headData, 54, outputFunc, outputStream);
     } else if (i == t42LocaTable) {
-      length = (nGlyphs + 1) * (locaFmt ? 4 : 2);
+      length = (nGlyphs.Int() + 1) * (locaFmt ? 4 : 2);
       dumpString(locaData, length, outputFunc, outputStream);
     } else if (i == t42GlyfTable) {
       glyfPos = tables[seekTable("glyf")].offset;
@@ -1909,7 +1910,7 @@
       parsedOk = gFalse;
       return;
     }
-    if (tables[i].len < (nGlyphs + 1) * (locaFmt ? 4 : 2)) {
+    if (tables[i].len < (nGlyphs.Int() + 1) * (locaFmt ? 4 : 2)) {
       nGlyphs = tables[i].len / (locaFmt ? 4 : 2) - 1;
     }
     for (j = 0; j <= nGlyphs; ++j) {
@@ -1958,7 +1959,7 @@
       goto err;
     }
     if (n > nGlyphs) {
-      n = nGlyphs;
+      n = nGlyphs.Int();
     }
     stringIdx = 0;
     stringPos = tablePos + 34 + 2*n;
--- xpdf-3.02/fofi/FoFiTrueType.h
+++ xpdf-3.02/fofi/FoFiTrueType.h
@@ -66,7 +66,7 @@
   // Return the mapping from CIDs to GIDs, and return the number of
   // CIDs in *<nCIDs>.  This is only useful for CID fonts.  (Only
   // useful for OpenType CFF fonts.)
-  Gushort *getCIDToGIDMap(int *nCIDs);
+  Gushort *getCIDToGIDMap(SafeInt *nCIDs);
 
   // Returns the least restrictive embedding licensing right (as
   // defined by the TrueType spec):
@@ -103,7 +103,7 @@
   // name (so we don't need to depend on the 'name' table in the
   // font).  The <cidMap> array maps CIDs to GIDs; it has <nCIDs>
   // entries.  (Not useful for OpenType CFF fonts.)
-  void convertToCIDType2(char *psName, Gushort *cidMap, int nCIDs,
+  void convertToCIDType2(char *psName, Gushort *cidMap, SafeInt nCIDs,
 			 GBool needVerticalMetrics,
 			 FoFiOutputFunc outputFunc, void *outputStream);
 
@@ -118,7 +118,7 @@
   // PostScript font name (so we don't need to depend on the 'name'
   // table in the font).  The <cidMap> array maps CIDs to GIDs; it has
   // <nCIDs> entries.  (Not useful for OpenType CFF fonts.)
-  void convertToType0(char *psName, Gushort *cidMap, int nCIDs,
+  void convertToType0(char *psName, Gushort *cidMap, SafeInt nCIDs,
 		      GBool needVerticalMetrics,
 		      FoFiOutputFunc outputFunc, void *outputStream);
 
@@ -159,10 +159,10 @@
   int seekTable(char *tag);
 
   TrueTypeTable *tables;
-  int nTables;
+  SafeInt nTables;
   TrueTypeCmap *cmaps;
   int nCmaps;
-  int nGlyphs;
+  SafeInt nGlyphs;
   int locaFmt;
   int bbox[4];
   GHash *nameToGID;
--- xpdf-3.02/fofi/FoFiType1C.cc
+++ xpdf-3.02/fofi/FoFiType1C.cc
@@ -101,9 +101,10 @@
   return encoding;
 }
 
-Gushort *FoFiType1C::getCIDToGIDMap(int *nCIDs) {
+Gushort *FoFiType1C::getCIDToGIDMap(SafeInt *nCIDs) {
   Gushort *map;
-  int n, i;
+  SafeInt n;
+  int i;
 
   // a CID font's top dict has ROS as the first operator
   if (topDict.firstOp != 0x0c1e) {
@@ -121,7 +122,7 @@
   }
   ++n;
   map = (Gushort *)gmallocn(n, sizeof(Gushort));
-  memset(map, 0, n * sizeof(Gushort));
+  memset(map, 0, n.Int() * sizeof(Gushort));
   for (i = 0; i < nGlyphs; ++i) {
     map[charset[i]] = i;
   }
@@ -437,7 +438,8 @@
   int *charStringOffsets;
   Type1CIndex subrIdx;
   Type1CIndexVal val;
-  int nCIDs, gdBytes;
+  SafeInt nCIDs;
+  int gdBytes;
   GString *buf;
   char buf2[256];
   GBool ok;
@@ -460,7 +462,7 @@
 
   // build the charstrings
   charStrings = new GString();
-  charStringOffsets = (int *)gmallocn(nCIDs + 1, sizeof(int));
+  charStringOffsets = (int *)gmallocn(nCIDs + SafeInt(1), sizeof(int));
   for (i = 0; i < nCIDs; ++i) {
     charStringOffsets[i] = charStrings->getLength();
     if ((gid = cidMap[i]) >= 0) {
@@ -476,13 +478,13 @@
       }
     }
   }
-  charStringOffsets[nCIDs] = charStrings->getLength();
+  charStringOffsets[nCIDs.Int()] = charStrings->getLength();
 
   // compute gdBytes = number of bytes needed for charstring offsets
   // (offset size needs to account for the charstring offset table,
   // with a worst case of five bytes per entry, plus the charstrings
   // themselves)
-  i = (nCIDs + 1) * 5 + charStrings->getLength();
+  i = (nCIDs.Int() + 1) * 5 + charStrings->getLength();
   if (i < 0x100) {
     gdBytes = 1;
   } else if (i < 0x10000) {
@@ -547,7 +549,7 @@
   (*outputFunc)(outputStream, "end def\n", 8);
 
   // CIDFont-specific entries
-  buf = GString::format("/CIDCount {0:d} def\n", nCIDs);
+  buf = GString::format("/CIDCount {0:d} def\n", nCIDs.Int());
   (*outputFunc)(outputStream, buf->getCString(), buf->getLength());
   delete buf;
   (*outputFunc)(outputStream, "/FDBytes 1 def\n", 15);
@@ -565,7 +567,7 @@
   }
 
   // FDArray entry
-  buf = GString::format("/FDArray {0:d} array\n", nFDs);
+  buf = GString::format("/FDArray {0:d} array\n", nFDs.Int());
   (*outputFunc)(outputStream, buf->getCString(), buf->getLength());
   delete buf;
   for (i = 0; i < nFDs; ++i) {
@@ -708,7 +710,7 @@
   (*outputFunc)(outputStream, "def\n", 4);
 
   // start the binary section
-  offset = (nCIDs + 1) * (1 + gdBytes);
+  offset = (nCIDs.Int() + 1) * (1 + gdBytes);
   buf = GString::format("(Hex) {0:d} StartData\n",
 			offset + charStrings->getLength());
   (*outputFunc)(outputStream, buf->getCString(), buf->getLength());
@@ -761,7 +763,7 @@
   int *cidMap;
   Type1CIndex subrIdx;
   Type1CIndexVal val;
-  int nCIDs;
+  SafeInt nCIDs;
   GString *buf;
   Type1CEexecBuf eb;
   GBool ok;
--- xpdf-3.02/fofi/FoFiType1C.h
+++ xpdf-3.02/fofi/FoFiType1C.h
@@ -151,7 +151,7 @@
 
   // Return the mapping from CIDs to GIDs, and return the number of
   // CIDs in *<nCIDs>.  This is only useful for CID fonts.
-  Gushort *getCIDToGIDMap(int *nCIDs);
+  Gushort *getCIDToGIDMap(SafeInt *nCIDs);
 
   // Convert to a Type 1 font, suitable for embedding in a PostScript
   // file.  This is only useful with 8-bit fonts.  If <newEncoding> is
@@ -216,7 +216,7 @@
   Type1CPrivateDict *privateDicts;
 
   int nGlyphs;
-  int nFDs;
+  SafeInt nFDs;
   Guchar *fdSelect;
   Gushort *charset;
   int gsubrBias;
--- xpdf-3.02/goo/GHash.cc
+++ xpdf-3.02/goo/GHash.cc
@@ -311,7 +311,8 @@
 void GHash::expand() {
   GHashBucket **oldTab;
   GHashBucket *p;
-  int oldSize, h, i;
+  int h, i;
+  SafeInt oldSize;
 
   oldSize = size;
   oldTab = tab;
@@ -365,7 +366,7 @@
   for (p = key->getCString(), i = 0; i < key->getLength(); ++p, ++i) {
     h = 17 * h + (int)(*p & 0xff);
   }
-  return (int)(h % size);
+  return (int)(h % size.Int());
 }
 
 int GHash::hash(char *key) {
@@ -376,5 +377,5 @@
   for (p = key; *p; ++p) {
     h = 17 * h + (int)(*p & 0xff);
   }
-  return (int)(h % size);
+  return (int)(h % size.Int());
 }
--- xpdf-3.02/goo/GHash.h
+++ xpdf-3.02/goo/GHash.h
@@ -55,7 +55,7 @@
   int hash(char *key);
 
   GBool deleteKeys;		// set if key strings should be deleted
-  int size;			// number of buckets
+  SafeInt size;			// number of buckets
   int len;			// number of entries
   GHashBucket **tab;
 };
--- xpdf-3.02/goo/GList.cc
+++ xpdf-3.02/goo/GList.cc
@@ -43,7 +43,7 @@
   if (length >= size) {
     expand();
   }
-  data[length++] = p;
+  data[(length++).Int()] = p;
 }
 
 void GList::append(GList *list) {
@@ -53,7 +53,7 @@
     expand();
   }
   for (i = 0; i < list->length; ++i) {
-    data[length++] = list->data[i];
+    data[(length++).Int()] = list->data[i];
   }
 }
 
@@ -62,7 +62,7 @@
     expand();
   }
   if (i < length) {
-    memmove(data+i+1, data+i, (length - i) * sizeof(void *));
+    memmove(data+i+1, data+i, (length.Int() - i) * sizeof(void *));
   }
   data[i] = p;
   ++length;
@@ -73,7 +73,7 @@
 
   p = data[i];
   if (i < length - 1) {
-    memmove(data+i, data+i+1, (length - i - 1) * sizeof(void *));
+    memmove(data+i, data+i+1, (length.Int() - i - 1) * sizeof(void *));
   }
   --length;
   if (size - length >= ((inc > 0) ? inc : size/2)) {
@@ -83,7 +83,7 @@
 }
 
 void GList::sort(int (*cmp)(const void *obj1, const void *obj2)) {
-  qsort(data, length, sizeof(void *), cmp);
+  qsort(data, length.Int(), sizeof(void *), cmp);
 }
 
 void GList::expand() {
--- xpdf-3.02/goo/GList.h
+++ xpdf-3.02/goo/GList.h
@@ -16,6 +16,7 @@
 #endif
 
 #include "gtypes.h"
+#include "gmem.h"
 
 //------------------------------------------------------------------------
 // GList
@@ -36,7 +37,7 @@
   //----- general
 
   // Get the number of elements.
-  int getLength() { return length; }
+  int getLength() { return length.Int(); }
 
   //----- ordered list support
 
@@ -76,9 +77,9 @@
   void shrink();
 
   void **data;			// the list elements
-  int size;			// size of data array
-  int length;			// number of elements on list
-  int inc;			// allocation increment
+  SafeInt size;			// size of data array
+  SafeInt length;		// number of elements on list
+  SafeInt inc;			// allocation increment
 };
 
 #define deleteGList(list, T)                        \
--- xpdf-3.02/goo/GString.cc
+++ xpdf-3.02/goo/GString.cc
@@ -224,7 +224,8 @@
 
 GString *GString::appendfv(char *fmt, va_list argList) {
   GStringFormatArg *args;
-  int argsLen, argsSize;
+  int argsLen; 
+  SafeInt argsSize;
   GStringFormatArg arg;
   int idx, width, prec;
   GBool reverseAlign, zeroFill;
--- xpdf-3.02/goo/gmem.cc
+++ xpdf-3.02/goo/gmem.cc
@@ -186,14 +186,335 @@
 #endif
 }
 
-void *gmallocn(int nObjs, int objSize) GMEM_EXCEP {
-  int n;
+SafeInt::SafeInt(const long long int cA) 
+{  
+  if (cA < -INT_MAX || INT_MAX < cA) 
+    integer_overflow("SafeInt::SafeInt(long long): "); 
+  c = cA;
+}
+ 
+SafeInt::SafeInt()
+{  }
+  
+SafeInt::SafeInt(const SafeInt& copy): c(copy.c) 
+{  }
+
+SafeInt SafeInt::create(const long long int cA) 
+{ 
+  return SafeInt(cA);
+}
+
+int SafeInt::Int(void) const
+{
+  return c;
+}
+
+void SafeInt::integer_overflow(const char * prefix)
+{ 
+  fprintf(stderr, "error: %sinteger overflow", prefix);  
+  exit (1); 
+}
+
+void SafeInt::division_by_zero(const char * prefix)
+{
+  fprintf(stderr, "error: %sdivide by zero", prefix);
+  exit(1);
+}
+
+void SafeInt::shift_is_negative(const char * prefix)
+{
+  fprintf(stderr, "warning: %sbitwise shift amount is negative", prefix);
+}
+
+SafeInt& SafeInt::operator=(const int& cA)
+{
+  *this = SafeInt(cA);
+  return *this;
+}
+
+bool SafeInt::operator==(const SafeInt& right) const
+{
+  return c == right.c;
+}
+
+bool SafeInt::operator!=(const SafeInt& right) const
+{
+  return c != right.c;
+}
+
+bool SafeInt::operator<(const SafeInt& right) const
+{ 
+  return c < right.c; 
+}
+
+bool SafeInt::operator<=(const SafeInt& right) const
+{ 
+  return c <= right.c; 
+}
+
+bool SafeInt::operator>(const SafeInt& right) const
+{ 
+  return c > right.c; 
+}
+
+bool SafeInt::operator>=(const SafeInt& right) const
+{ 
+  return c >= right.c; 
+}
+
+bool SafeInt::operator==(const int& right) const
+{
+  return c == right;
+}
+
+bool SafeInt::operator!=(const int& right) const
+{
+  return c != right;
+}
+
+bool SafeInt::operator<(const int& right) const
+{
+  return c < right;
+}
+
+bool SafeInt::operator<=(const int& right) const
+{
+  return c <= right;
+}
+
+bool SafeInt::operator>(const int& right) const
+{
+  return c > right;
+}
+
+bool SafeInt::operator>=(const int& right) const
+{
+  return c >= right;
+}
+
+bool operator==(const int& left, const SafeInt& right)
+{ 
+  return left == right.c; 
+}
+
+bool operator!=(const int& left, const SafeInt& right)
+{
+  return left != right.c;
+}
+
+bool operator<(const int& left, const SafeInt& right)
+{
+  return left < right.c;
+}
+
+bool operator<=(const int& left, const SafeInt& right)
+{
+  return left <= right.c;
+}
+
+bool operator>(const int& left, const SafeInt& right)
+{
+  return left > right.c;
+}
+
+bool operator>=(const int& left, const SafeInt& right)
+{
+  return left >= right.c;
+}
+
+SafeInt SafeInt::operator+() const 
+{ 
+  return SafeInt(*this); 
+}
+
+SafeInt SafeInt::operator+(const SafeInt& right) const
+{ 
+  if (c*right.c > 0 &&
+      ((c > 0 && c > INT_MAX - right.c) || 
+       (c < 0 && c < -INT_MAX - right.c))) 
+    integer_overflow("SafeInt::operator+(): ");
+  return SafeInt(c + right.c); 
+}
+
+SafeInt SafeInt::operator-() const
+{ 
+  return SafeInt(-c); 
+}
+
+SafeInt SafeInt::operator-(const SafeInt& right) const
+{ 
+  return *this + (-right); 
+}
+
+SafeInt SafeInt::operator*(const SafeInt& right) const
+{ 
+  if (right.c != 0 && c*right.c/right.c != c) 
+    integer_overflow("SafeInt::operator*(): ");
+  return SafeInt(c * right.c); 
+}
+
+SafeInt SafeInt::operator/(const SafeInt& right) const
+{ 
+  return SafeInt(c / right.c); 
+}
+
+SafeInt SafeInt::operator%(const SafeInt& right) const
+{
+  return SafeInt(c % right.c);
+}
+
+SafeInt SafeInt::operator/(const int& right) const
+{
+  if (right == 0)
+    division_by_zero("SafeInt::operator/(): ");
+  return SafeInt(c / right);
+}
+
+SafeInt SafeInt::operator%(const int& right) const
+{
+  return SafeInt(c % right);
+}
+
+SafeInt& SafeInt::operator+=(const SafeInt& right) 
+{ 
+  *this = *this + right; 
+  return *this; 
+}
+
+SafeInt& SafeInt::operator-=(const SafeInt& right) 
+{ 
+  *this = *this - right; 
+  return *this; 
+}
+
+SafeInt& SafeInt::operator*=(const SafeInt& right)
+{ 
+  *this = *this * right; 
+  return *this; 
+}
+
+SafeInt& SafeInt::operator/=(const SafeInt& right)
+{ 
+  *this = *this / right; 
+  return *this; 
+}
+
+SafeInt& SafeInt::operator%=(const SafeInt& right)
+{
+  *this = *this % right;
+  return *this;
+}
+
+SafeInt& SafeInt::operator/=(const int& right)
+{
+  *this = *this / right;
+  return *this;
+}
+
+SafeInt& SafeInt::operator%=(const int& right)
+{
+  *this = *this % right;
+  return *this;
+}
+
+SafeInt& SafeInt::operator++()
+{ 
+  *this += one; 
+  return *this; 
+}
+
+SafeInt SafeInt::operator++(int)
+{ 
+  SafeInt res(*this); 
+  *this += one; 
+  return res; 
+}
+
+SafeInt& SafeInt::operator--()
+{ 
+  *this -= one; 
+  return *this; 
+}
+
+SafeInt SafeInt::operator--(int)
+{ 
+  SafeInt res(*this); 
+  *this -= one; 
+  return res; 
+}
+
+SafeInt operator+(const int& left, const SafeInt& right)
+{
+  return SafeInt(left) + right;
+}
+
+SafeInt operator-(const int& left, const SafeInt& right)
+{
+  return SafeInt(left) - right;
+}
+
+SafeInt operator*(const int& left, const SafeInt& right)
+{
+  return SafeInt(left) * right;
+}
+
+SafeInt operator/(const int& left, const SafeInt& right)
+{
+  return SafeInt(left) / right;
+}
+
+SafeInt operator%(const int& left, const SafeInt& right)
+{
+  return SafeInt(left) % right;
+}
+
+SafeInt SafeInt::operator<<(const int offset)
+{
+  if (offset < 0)
+  {
+    shift_is_negative("SafeInt::operator<<(): ");
+    return *this >> -offset;
+  }
+
+  if ((c & (-1 << (sizeof(c)*8 - offset))) != 0)
+    integer_overflow("SafeInt::operator<<(): ");
+ return SafeInt(c << offset);
+}
+
+SafeInt SafeInt::operator>>(const int offset)
+{
+  if (offset < 0)
+  {
+    shift_is_negative("SafeInt::operator>>(): ");
+    return *this << -offset;
+  }
+
+  return SafeInt(c >> offset);
+}
+
+SafeInt& SafeInt::operator<<=(const int offset)
+{
+  *this = *this << offset;
+  return *this; 
+}
+
+SafeInt& SafeInt::operator>>=(const int offset)
+{
+  *this = *this >> offset;
+  return *this;
+}
+
+const SafeInt SafeInt::zero = SafeInt(0);
+const SafeInt SafeInt::one = SafeInt(1);
+
+void *gmallocn(SafeInt nObjs, SafeInt objSize) GMEM_EXCEP {
+  SafeInt n;
 
-  if (nObjs == 0) {
+  if (nObjs == SafeInt::create(0)) {
     return NULL;
   }
   n = nObjs * objSize;
-  if (objSize <= 0 || nObjs < 0 || nObjs >= INT_MAX / objSize) {
+  if (objSize <= SafeInt::create(0) || nObjs < SafeInt::create(0)) {
 #if USE_EXCEPTIONS
     throw GMemException();
 #else
@@ -201,20 +522,20 @@
     exit(1);
 #endif
   }
-  return gmalloc(n);
+  return gmalloc(n.Int());
 }
 
-void *greallocn(void *p, int nObjs, int objSize) GMEM_EXCEP {
-  int n;
+void *greallocn(void *p, SafeInt nObjs, SafeInt objSize) GMEM_EXCEP {
+  SafeInt n;
 
-  if (nObjs == 0) {
+  if (nObjs == SafeInt::create(0)) {
     if (p) {
       gfree(p);
     }
     return NULL;
   }
   n = nObjs * objSize;
-  if (objSize <= 0 || nObjs < 0 || nObjs >= INT_MAX / objSize) {
+  if (objSize <= SafeInt::create(0) || nObjs < SafeInt::create(0)) {
 #if USE_EXCEPTIONS
     throw GMemException();
 #else
@@ -222,7 +543,7 @@
     exit(1);
 #endif
   }
-  return grealloc(p, n);
+  return grealloc(p, n.Int());
 }
 
 void gfree(void *p) {
--- xpdf-3.02/goo/gmem.h
+++ xpdf-3.02/goo/gmem.h
@@ -28,6 +28,98 @@
 
 #endif // USE_EXCEPTIONS
 
+class SafeInt
+{
+  int c;
+ 
+public:
+  SafeInt();
+  SafeInt(const SafeInt& copy);
+  SafeInt(const long long int cA);
+  static SafeInt create(const long long int cA);
+  int Int(void) const;
+
+  const static SafeInt zero;
+  const static SafeInt one;
+  
+  static void integer_overflow(const char * prefix = NULL);
+  static void division_by_zero(const char * prefix = NULL);
+  static void shift_is_negative(const char * prefix = NULL);
+
+  SafeInt& operator=(const int& cA);
+
+  bool operator==(const SafeInt& right) const;
+  bool operator!=(const SafeInt& right) const;
+  bool operator<(const SafeInt& right) const;
+  bool operator<=(const SafeInt& right) const;
+  bool operator >(const SafeInt& right) const;
+  bool operator >=(const SafeInt& right) const;
+
+  bool operator==(const int& right) const;
+  bool operator!=(const int& right) const;
+  bool operator<(const int& right) const;
+  bool operator<=(const int& right) const;
+  bool operator >(const int& right) const;
+  bool operator >=(const int& right) const;
+
+  friend bool operator ==(const int &left, const SafeInt& right);
+  friend bool operator !=(const int &left, const SafeInt& right);
+  friend bool operator <(const int &left, const SafeInt& right);
+  friend bool operator <=(const int &left, const SafeInt& right);
+  friend bool operator >(const int &left, const SafeInt& right);
+  friend bool operator >=(const int &left, const SafeInt& right);
+
+  SafeInt operator+() const; 
+  SafeInt operator+(const SafeInt& right) const;
+  SafeInt operator-() const;
+  SafeInt operator-(const SafeInt& right) const;
+  SafeInt operator*(const SafeInt& right) const;
+  SafeInt operator/(const SafeInt& right) const;
+  SafeInt operator%(const SafeInt& right) const;
+
+  SafeInt operator/(const int& right) const;
+  SafeInt operator%(const int& right) const;
+
+  SafeInt& operator+=(const SafeInt& right); 
+  SafeInt& operator-=(const SafeInt& right); 
+  SafeInt& operator*=(const SafeInt& right);
+  SafeInt& operator/=(const SafeInt& right);
+  SafeInt& operator%=(const SafeInt& right);
+
+  SafeInt& operator/=(const int& right);
+  SafeInt& operator%=(const int& right);
+
+  friend SafeInt operator+(const int& left, const SafeInt& right);
+  friend SafeInt operator-(const int& left, const SafeInt& right);
+  friend SafeInt operator*(const int& left, const SafeInt& right);
+  friend SafeInt operator/(const int& left, const SafeInt& right);
+  friend SafeInt operator%(const int& left, const SafeInt& right);
+
+  SafeInt& operator++();
+  SafeInt operator++(int);
+  SafeInt& operator--();
+  SafeInt operator--(int);
+
+  SafeInt operator<<(const int offset);
+  SafeInt operator>>(const int offset);
+
+  SafeInt& operator<<=(const int offset);
+  SafeInt& operator>>=(const int offset);
+};
+
+bool operator==(const int& left, const SafeInt& right);
+bool operator!=(const int& left, const SafeInt& right);
+bool operator<(const int& left, const SafeInt& right);
+bool operator<=(const int& left, const SafeInt& right);
+bool operator>(const int& left, const SafeInt& right);
+bool operator>=(const int& left, const SafeInt& right);
+
+SafeInt operator+(const int& left, const SafeInt& right);
+SafeInt operator-(const int& left, const SafeInt& right);
+SafeInt operator*(const int& left, const SafeInt& right);
+SafeInt operator/(const int& left, const SafeInt& right);
+SafeInt operator%(const int& left, const SafeInt& right);
+
 #ifdef __cplusplus
 extern "C" {
 #endif
@@ -50,8 +142,8 @@
  * bytes, but there is an additional error check that the total size
  * doesn't overflow an int.
  */
-extern void *gmallocn(int nObjs, int objSize) GMEM_EXCEP;
-extern void *greallocn(void *p, int nObjs, int objSize) GMEM_EXCEP;
+extern void *gmallocn(SafeInt nObjs, SafeInt objSize) GMEM_EXCEP;
+extern void *greallocn(void *p, SafeInt nObjs, SafeInt objSize) GMEM_EXCEP;
 
 /*
  * Same as free, but checks for and ignores NULL pointers.
